unit Unit1;
{ status

    7-01-2011: search ok, continued search = wrong (history blocks good
                                                    board positions as well)
               added nr field to history...&...deleted
    9-01-2011  shortest solution 116 moves
               BW & FW buffers. BW buffer problem: board states repeated occ.
    shift#5:   BWhistory[0] boardcode set at create time by "resetgame"
               BWhist. problem fixed (double j incremet removed)
   10-01-2011  added CPUclock to show exection time
               added statistics
   12-01-2011  BAF added (check against back & forth moves)
               time reduced from 196 to 138 secs. (116 moves)
   13-01-2011  FWhistory split in 4 parts of 7500. time = 28 secs. (116 moves)
   17-01-2011  backspace error fixed in play mode
   18-01-2011  fixed range error if GO after solution in 200 moves
               removed range,overflow testing: 22secs for solution in 116 moves

 approach

   basically, the "brute force" method is used to find solutions
   search time is reduced by

     1. limiting the allowed number of moves
     2. adding a "backward" buffer (holds previous board states of
                                    moves 1..current move)
     3. adding "forward" buffer (holds boardstates of moves taken back in search.
                                 coded together with move number)
     4. adding BAF stacks . Stack per board field. Number of block is pushed
                            to stacks of vacated fields.

   buffers prevent reoccurring board states.
   In case of forward buffer hit, the move number must be higher then the
   move number stored, else solutions may be missed.
   The BAF (back&forth) check prevents silly moves as shifting block "A" right,
   shift some other blocks at a different area then shift block "A" left to
   it's original position without having used the vacated fields.

  options

    SHIFT game
    single player puzzle

    - find solutions,
    - replay solutions,
    - let computer search for solutions
    - save / reload moves
    - print results
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, shellapi,printers;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    playBtn: TSpeedButton;
    replayBtn: TSpeedButton;
    searchBtn: TSpeedButton;
    msgtext: TStaticText;
    PaintBox2: TPaintBox;
    Label1: TLabel;
    Label2: TLabel;
    resetBtn: TSpeedButton;
    PaintBox3: TPaintBox;
    Label3: TLabel;
    goBtn: TSpeedButton;
    Image1: TImage;
    maxmovetext: TStaticText;
    maxmoveUpDown: TUpDown;
    Label4: TLabel;
    Timer1: TTimer;
    helpBtn: TSpeedButton;
    stepcheck: TCheckBox;
    Label5: TLabel;
    statBtn: TBitBtn;
    BackBtn: TSpeedButton;
    Image2: TImage;
    Label7: TLabel;
    pr_image: TImage;
    pr_setup: TImage;
    open_image: TImage;
    save_image: TImage;
    PrinterSetupDialog1: TPrinterSetupDialog;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox3Paint(Sender: TObject);
    procedure resetBtnClick(Sender: TObject);
    procedure goBtnClick(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure playBtnClick(Sender: TObject);
    procedure stepcheckClick(Sender: TObject);
    procedure statBtnClick(Sender: TObject);
    procedure BackBtnClick(Sender: TObject);
    procedure maxmoveUpDownMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label7Click(Sender: TObject);
    procedure Label7MouseEnter(Sender: TObject);
    procedure Label7MouseLeave(Sender: TObject);
    procedure open_imageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure open_imageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure helpBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2,help_unit;

{$R *.dfm}

const endFWHistory = 7500;        //top entry in history table per buffer 0..3
      absmaxmoveNr = 200;          //top entry in move list
      brushcolor3 = $e0ffff;       //paintbox3 background color

type  Tblocktype = record
                    w,h : byte;  //width,height
                    footprint : DWORD;
                    color : DWORD;
                   end;

      TBlock = record
               bt  : byte;        //block type 1,2,3,4
               pos : byte;        //position 0..19
               text: char;        //character in block
              end;

      TGame = array[1..10] of TBlock;

     Tmove = record           //for move list
              mblk : byte;
              mdir : byte;
              alldirs : byte;   //all possible directions for block
             end;

     TTimerdata = record
                   mblk : byte;     //blockNr to move
                   mbrect : Trect;
                   dx,dy : integer; //move increment value
                   count : byte;
                  end;

     TBoardCode = array[1..4] of DWORD; //1: footprints of type 1 blocks..etc.
                                        //for history

     Tgamestate = (gstIdle,gstPause,gstSolved,gstEnd);
     TmainBtn = (mbPlay,mbReplay,mbSearch,mbNone);
     TsysBtn = (sysNone,sysOpen,sysSave,sysPrint,sysSetup);

     TFWhistory = array[0..4,1..endFWhistory] of DWORD;
     PFWhistory = ^TFWhistory;

const blocktype : array[1..4] of TBlockType =             //dim h x v
      ((w: 1; h: 1; footprint:  $1; color: $ff6000),      //1 x 1
       (w: 2; h: 1; footprint:  $3; color: $ff6000),      //2 x 1
       (w: 1; h: 2; footprint: $11; color: $ff6000),      //1 x 2
       (w: 2; h: 2; footprint: $33; color: $0000ff));     //2 x 2

      Game1 : TGame =
       ((bt: 3; pos:  0; text:'A'),               //postitions:
        (bt: 4; pos:  1; text:'X'),               //  0  1  2  3
        (bt: 3; pos:  3; text:'B'),               //  4  5  6  7
        (bt: 3; pos:  8; text:'C'),               //  8  9 10 11
        (bt: 2; pos:  9; text:'D'),               // 12 13 14 15
        (bt: 3; pos: 11; text:'E'),               // 16 17 18 19
        (bt: 1; pos: 13; text:'F'),
        (bt: 1; pos: 14; text:'G'),
        (bt: 1; pos: 16; text:'H'),
        (bt: 1; pos: 19; text:'I'));

      hspace : array[1..3] of byte = (50,85,120);//field width in moves list
      dToArrow : array[1..8] of byte = (174,173,0,172,0,0,0,175);

procedure paintblock(blk : byte);forward;

var blocks : Tgame;                 //description of the 10 blocks
    movelist : array[1..absmaxmoveNr] of Tmove;
    moveNr : integer;              //current move nr, point to next move
    topMoveNr : integer;           //highest move in moves list
    endmoveNr : integer;           //highest move possible
    boardcode : TBoardCode;
    xmove : Tmove;                 //trial move in search function

    FW0,FW1,FW2,FW3 : TFWhistory;
    FWtop : array[0..3] of WORD;
    BWhistory : array[1..4,0..absmaxmoveNr] of DWORD;
    topBWhistory : integer;

    bm : Tbitmap;
    exbm : Tbitmap;                //example bitmap
    modrect : Trect;
    rectfull : boolean;

    gamestate : Tgamestate;
    mainbutton : TmainBtn;
    sysbutton : TsysBtn;
    stepmode : boolean = false;
    stopflag : boolean = false;
    eventblock : boolean;          //block all mouse/kbrd events

    oldblock : byte=0;             //selected block to shift
    offsetX,offsetY : integer;     //mouse offset in selected block
    blockrect : Trect;             //rectangle of moving block
    grip: boolean = false;         //block can move, mousedown
    moveblock : boolean = false;   //block can move
    selectBlockNr : byte;          //block selected by keyboard
    movedirs : byte;               //possible move directions
    movedata : Ttimerdata;         //move data for timer

    CPUcycles : double;            //CPU cycles per microsecond
    PROCcycles: Int64;             //processing cycles
    stat : Tstat;                  //statistics

    playmove1 : boolean;           //player started frommove 1

    BAF   : array[0..19,0..50] of byte; //back & forth check 20 stacks
    BAFh  : array[0..19] of byte;       //height per stack

const FWbuffer : array[0..3] of PFWhistory = (@FW0,@FW1,@FW2,@FW3);

// --- CPU clock ---

procedure GetCPUticks(var clock : Int64);
begin
 asm
   mov ECX,clock //save address
   RDTSC         // put CPU ticks in EAX (bits 0..31) and EDX (32..63)
   mov [ECX],EAX
   add ECX,4
   mov [ECX],EDX
 end;
end;

function CyclesPerMicroSecond : double;
//calculate the clock speed
var t1,t2 : Int64;
    t : DWORD;
begin
 t := GetTickCount;
 while t=GetTickCount do;
 GetCPUTicks(t1); //get the time-stamp counter value
 t := t + 500;
 while GetTickCount < t do;   // delay for 0,5 sec
 GetCPUTicks(t2);  // clock cycle number in 0,5 second
 result := (t2-t1) * 2e-6;
end;

// --- low level paint --------

function getblockrect(blk : byte): Trect;
//return rectangle of block blk
var w,h : byte;
begin
 with blocks[blk] do
  begin
   result.left := (pos and $3)*100;
   result.Top := (pos shr 2)*100;
   w := blocktype[bt].w;
   h := blocktype[bt].h;
   result.Right := result.Left + w*100;
   result.Bottom := result.Top + h*100;
  end;
end;

procedure addrect(const r : Trect);
//add rectangle to modrect
begin
 if rectfull then
  begin
   with modrect do
    begin
     if r.left < Left then left := r.Left;
     if r.Top < top then top := r.Top;
     if r.right > right then right := r.Right;
     if r.Bottom > bottom then bottom := r.Bottom;
    end;
  end
  else begin
        modrect := r;
        rectfull := true;
       end;
end;

procedure addFieldrect(fld : byte);
//add rectangle of field to modrect
var r : Trect;
begin
 with r do
  begin
   left := (fld and $3)*100;
   right := left + 100;
   top := (fld shr 2) *100;
   bottom := top + 100;
  end;
 addrect(r);
end;

procedure addblockrect(blk : byte);
var r : Trect;
begin
 r := getBlockrect(blk);
 addrect(r);
end;

procedure bmToBox;
//copy rectangle modrect of bm to paintbox1
begin
 if rectfull then
  begin
   form1.PaintBox1.Canvas.CopyRect(modrect,bm.Canvas,modrect);
   rectfull := false;
  end; 
end;

procedure selectblock(nr : byte);
//block selected by keyboard
//place circle around character
var n : byte;
begin
 if selectblockNr <> 0 then
  begin
   n := selectblockNr;
   selectblockNr := 0;
   paintblock(n);
  end;

 if Nr <> 0 then
  begin
   selectblockNr := nr;
   paintblock(nr);
  end;
 bmtobox;
end;

procedure paintblockXY(x,y : integer; blk : byte);
//paint block bk at (x,y) in bm
//ct: colortype colors 1..5, (1..4 egdes, 5 center)
var x1,y1: integer;
    w,h,i : byte;
    color : DWORD;
    r : Trect;
begin
 with blocks[blk] do
  with bm do with canvas do
  begin
   r := getblockrect(blk);
   w := r.Right-r.Left;
   h := r.Bottom-r.top;
   r.right := x + w;
   r.Bottom := y + h;
   r.Left := x;
   r.Top := y;
   color := blocktype[bt].color;
   pen.Width := 1;
   brush.Color := color;
   brush.Style := bssolid;
   fillrect(r);
   for i := 0 to 3 do
    begin
     pen.color := color or $a0a0a0;
     moveto(r.right-1-i,y+i);
     lineto(r.left+i,r.top+i);
     lineto(r.left+i,r.bottom-1-i);
     pen.color := color and $c0c0c0;
     lineto(r.right-1-i,r.bottom-1-i);
     lineto(r.right-1-i,r.top+i);
    end;
   brush.Style := bsClear;
   font.Name := 'arial';
   font.Height := 40;
   font.color := $000000;
   font.Style := [fsBold];
   x1 := x + (w - textwidth(text)) div 2;
   y1 := y + (h - textheight(text)) div 2;
   textout(x1+2,y1+2,text);
   font.Color := $ffffff;
   textout(x1,y1,text);

   if blk = selectblockNr then     //if selected by keyboard
    begin
     x1 := x + w div 2;
     y1 := y + h div 2;
     pen.Width := 3;
     pen.Color := $00ffff;
     brush.Style := bsClear;
     ellipse(x1-20,y1-20,x1+20,y1+20);
    end;
  end;//with bm
 addrect(r);
end;

procedure paintblock(blk : byte);
var r : Trect;
begin
 r := getblockrect(blk);
 paintblockXY(r.Left,r.top,blk);
end;

procedure eraserect(const r : Trect);
//paint rectangle r white in bitmap bm
begin
 with bm.canvas do
  begin
   brush.color := $ffffff;
   brush.Style := bsSolid;
   fillrect(r);
   addrect(r);
  end;
end;

procedure paintex;
//paint example , solved game
var x1,y1,x2,y2 : integer;
    i : byte;
begin
 with exbm do with canvas do
  begin
   brush.color := $ffffff;
   brush.Style := bsSolid;
   pen.Width := 1;
   fillrect(rect(0,0,width,height));
   pen.Color := $c0c0c0;
   for i := 1 to 3 do
    begin
     moveto(15*i,0);
     lineto(15*i,height);
    end;
   for i := 1 to 4 do
    begin
     moveto(0,15*i);
     lineto(width,15*i);
    end;
   x1 := 15;
   x2 := 45;
   y1 := 45;
   y2 := 75;
   brush.Color := $0000ff;
   fillrect(rect(x1,y1,x2,y2));
   for i:= 0 to 1 do
    begin
     pen.color := $8080ff;
     moveto(x2-1-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-1-i);
     pen.color := $000070;
     lineto(x2-1-i,y2-1-i);
     lineto(x2-1-i,y1+i);
    end;
   brush.Style := bsClear;
   font.name := 'arial';
   font.height := 20;
   font.style := [fsBold];
   font.color := $000000;
   textout(25,52,'X');
   font.color := $ffffff;
   textout(23,50,'X');
  end;
 form1.PaintBox2.Invalidate;
end;

function XYtoBlock(x,y :integer) : byte;
//return block Nr mouse pointer is positioned over
//return 0 if not on block
var i : byte;
    h,w,posX,posY : integer;
    hit : boolean;
begin
 i := 0;
 repeat
  inc(i);
  with blocks[i] do
   begin
    posX := (pos and $3) * 100;
    posY := (pos shr 2) * 100;
    w := (blocktype[bt].w) * 100;
    h := (blocktype[bt].h) * 100;
    hit := (X >= posX+5) and (X < posX+w-5) and
           (Y >= posY+5) and (Y < posY+h-5);
   end;
  until hit or (i = 10);
 if hit then result := i else result := 0;
end;

//--- boardcode ---

procedure makeboardCode;
//scan all blocks
var n, bt,pos,fp : byte;
begin
 for n := 1 to 4 do boardcode[n] := 0;
 for n := 1 to 10 do
  begin
   bt := blocks[n].bt;
   pos := blocks[n].pos;
   fp := blocktype[bt].footprint;
   boardcode[bt] := boardcode[bt] or (fp shl pos);
  end;
end;

function getfootprint(blk : byte) : DWORD;
var bt : byte;
begin
 bt := blocks[blk].bt;
 result := blocktype[bt].footprint shl blocks[blk].pos;
end;

//--- move directions ---

procedure MakeMovedirs(blk : byte; var dir : byte);
//return move directions in dir for block blk
//dir : directions (bit 0: right; 1: up; 2: left; 3: down)
//use Ebits to make direction code d
var w,h,p,t : byte;
    ok : boolean;
    mask,fp,emptybits : DWORD;
begin
 emptybits := 0;
 for p := 1 to 4 do emptybits := emptybits or boardcode[p];
 dir := 0;
 p := blocks[blk].pos;
 t := blocks[blk].bt;
 w := blocktype[t].w - 1;   //0..1
 h := blocktype[t].h - 1;   //0..1
 fp := blocktype[t].footprint shl p;

//--- dir 0: right

 if (p+w) and $3 < 3 then
  begin
    mask := fp or (fp shl 1);
    mask := mask xor fp;
   Ok := (mask and emptybits) = 0;
   if ok then dir := 1;//set right flag
  end;

//--- dir 1: up

 if (p shr 2) > 0 then
  begin
   mask := fp or (fp shr 4);
   mask := mask xor fp;
   ok := (mask and emptybits) = 0;
   if ok then dir := dir or $2;
  end;

//--- dir 2: left

 if (p and $3) > 0 then
  begin
   mask := fp or (fp shr 1);
   mask := mask xor fp;
   ok := (mask and emptybits) = 0;
   if ok then dir := dir or $4;
  end;

//--- dir 3: down

 if (p shr 2) + h < 4 then
  begin
   mask := fp or (fp shl 4);
   mask := mask xor fp;
   ok := (mask and emptybits) = 0;
   if ok then dir := dir or $8;
  end;
end;

//--- history ---

function getFWbuffer : byte;
//return FWhistory index 0..3
var i,d : byte;
begin
 d := 0;
 for i := 7 to 10 do d := d xor blocks[i].pos;
 result := d and $3;
end;

function FWhistoryCheck : integer;
//check block position occurred before
//return 0 if not found, hit index if match found
var i,j,top : integer;
    eq : boolean;
    n : byte;
    FW : PFWhistory;
begin
 n := getFWbuffer;    //buffer 0..3
 FW := FWbuffer[n];
 top := FWtop[n];
 j := 1;
 while j <= top do
  begin
   i := 0;
   repeat
    inc(i);
    eq := FW^[i,j] = boardcode[i];
   until (i = 4) or (eq = false);
   if eq then
    begin
     result := j;
     exit;
    end;
   inc(j);
 end;
 result := 0;
end;

function addFWhistory : boolean;
var i,n : byte;
    FWHit,top : integer;
    FW : PFWhistory;
begin
 n := getFWbuffer;
 FW := FWbuffer[n];
 top := FWtop[n];
 FWHit := FWhistoryCheck;
 if FWHit <> 0 then            //allready in FWhistory
  begin
   if FW^[0,FWHit] > moveNr then FW^[0,FWHit] := moveNr;
   result := true;
   exit;
  end;

 if top = endFWhistory then result := false
 else
  begin
   inc(top);
   for i := 1 to 4 do FW^[i,top] := boardcode[i];
   FW^[0,top] := moveNr;
   FWtop[n] := top;
   result := true;
  end;
end;

function BWhistoryOK : boolean;
//return true if boardcode not in history
//add new boardcode to history at [moveNr]
var i,j : integer;
    eq : boolean;
begin
 j := 0;
 while j < moveNr do
  begin
   i := 0;
   repeat
    inc(i);
    eq := BWhistory[i,j] = boardcode[i];
   until (i = 4) or (eq = false);
   if eq then
    begin
     result := false;
     exit;
    end;
   inc(j);
 end;

 result := true;
end;

procedure addBWhistory;
//add boardcode to BWhistory at [moveNr]
var i : byte;
begin
 for i := 1 to 4 do BWhistory[i,moveNr] := boardcode[i];
end;

procedure resetHistory;
//erase BWhistory, FWhistory
//BW history 0 holds initial boardcode, not changed
var i,j : longInt;
begin
 for j := 1 to absmaxmoveNr do
  for i := 1 to 4 do BWhistory[i,j] := 0;

 for i := 0 to 3 do FWtop[i] := 0;

 for j := 1 to endFWhistory do
  for i := 0 to 4 do
   begin
    FW0[i,j] := 0;
    FW1[i,j] := 0;
    FW2[i,j] := 0;
    FW3[i,j] := 0;
   end;
end;

function checkhistory : boolean;
//check both forward,backward history tables;
var FWHit : integer;
    FW : PFWhistory;
    n : byte;
begin
 result := BWhistoryOK;
 if result = false then
  begin
   inc(stat.BWrejects);
   exit;
  end;

 FWHit := FWhistoryCheck;
 if FWHit <> 0 then
  begin
   n := getFWbuffer;
   FW := FWbuffer[n];
    if moveNr >= FW^[0,FWHit] then
     begin
      inc(stat.FWrejects);
      result := false;
     end;
   end;
end;

function newblockpos(pos, dir : byte) : byte;
//adjust position of block acc. to direction dir
//move must be possible
begin
 case dir of
  1 : result := pos + 1;
  2 : result := pos - 4;
  4 : result := pos - 1;
  8 : result := pos + 4;
 end;
end;

function oldblockpos(pos, dir : byte) : byte;
//adjust position of block acc. to opposite direction dir
//move must be possible
begin
 case dir of
  1 : result := pos - 1;
  2 : result := pos + 4;
  4 : result := pos + 1;
  8 : result := pos - 4;
 end;
end;

//-- BAF procedures ---

procedure pushBAF(F : DWORD; d : byte);
//F is bits 0..19, 1 bit per field
//push data d on BAF stack if bit is set

var h,i : byte;
   mask : DWORD;
begin
 i := 0;
 mask := 1;
 while F <> 0 do
  begin
   if mask and F <> 0 then
    begin
     h := BAFh[i];
     inc(h);
     BAFh[i] := h;
     BAF[i,h] := d;
     F := F xor mask;
    end;
    inc(i);
    mask := mask shl 1;
  end;//while
end;

procedure popBAF(F : DWORD);
//F is bits 0..19
//pop data from BAF stack if bit is set
var h,i : byte;
    mask : DWORD;
begin
 mask := 1;
 i := 0;
 while F <> 0 do
  begin
   if mask and F <> 0 then
    begin
     dec(BAFh[i]);
     F := F xor mask;
    end;
   inc(i);
   mask := mask shl 1;  
  end;//while
end;

function checkBAF(F : DWORD; blk : byte) : boolean;
//F is bits 0..19
//test back & forth shifting of block
//return true if block returns to previously vacated position
var i : byte;
    mask : DWORD;
begin
 mask := 1;
 i := 0;
 while F <> 0 do
  begin
   if mask and F <> 0 then
    begin
     if BAF[i,BAFh[i]] = blk then
      begin
       result := true;
       exit;
      end;
     F := F xor mask;
    end;
   inc(i);
   mask := mask shl 1;
  end;//while
 result := false;
end;

//--- search for solutions ---

function search(timeout : integer) : TGamestate;
//search for solutions
//modify moveslist, historylist
//do not modify displays
label start,testmove,nextmove1,nextmove2, moveback;
var bt,i,oldpos : byte;
    boardcodeDiff : DWORD;
    FP1,FP2,BAF1,BAF2 : DWORD;
begin

start :

 if timeout = 0 then
  begin
   result := gstPause;   //pause to show results
   topmoveNr := moveNr - 1;
   exit;
  end
 else dec(timeout);

 if moveNr > endMoveNr then goto moveback;

 with xmove do           //setup 1st xmove
  begin
   mblk := 1;
   mdir := 1;
   makeboardcode;
   makemovedirs(1,alldirs);
  end;

testmove:

 with xmove do
  begin
   if alldirs = 0 then goto nextmove2;             //no move possible
   if mdir and alldirs = 0 then goto nextmove1;    //wrong direction

   alldirs := alldirs xor mdir;                    //remove direction
   bt := blocks[xmove.mblk].bt;                    //get block type
   if (bt = 4) and (mdir = 2) then goto nextmove1; //X block may not move up
   inc(stat.TRIALmoves);

 //-- generate next board code

   oldpos := blocks[mblk].pos;        //save position and boardcode
   FP1 := getfootprint(mblk);
   blocks[mblk].pos := newblockpos(oldpos,mdir);  //new block position
   FP2 := getfootprint(mblk);
   boardcodediff := FP1 xor FP2;
   BAF1 := (FP2 xor $fffff) and FP1; //1 : positions vacated
   BAF2 := (FP1 xor $fffff) and FP2; //1 : positions covered
   if checkBAF(BAF2,mblk) then
    begin
     blocks[mblk].pos := oldpos;     //restore block position
     goto nextmove1;
    end;

   boardcode[bt] := boardcode[bt] xor boardcodeDiff;

 //-- check history, record move if OK

   if checkhistory then
    begin
     movelist[moveNr] := xmove;                   //record move
     addBWhistory;                                //boardcode to BWhistory
     pushBAF(BAF1,mblk);                          //vacated fields
     pushBAF(BAF2,0);                             //covered fields
     inc(moveNr);                                 //point to next move

     if (bt = 4) and (blocks[2].pos = 13) then    //test puzzle solved
      begin                                       //solved
       result := gstSolved;
       topmoveNr := moveNr-1;
       exit;
      end
      else goto start;                             //next move
    end //checkhistory OK
     else                                         //old position detected or
      begin                                       //history full
       blocks[mblk].pos := oldpos;                //place back
       boardcode[bt] := boardcode[bt] xor boardcodeDiff; //xor back old state
      end;
  end;//with

nextmove1:                   //next direction

  with xmove do
   begin
    mdir := mdir shl 1;
    if mdir <= $8 then goto testmove;
   end;

nextmove2:                  //next block

  with xmove do
   begin
    mdir := 1;
    inc(mblk);
    if mblk > 10 then goto moveback;

    makemovedirs(mblk,alldirs);     //for new block
    goto testmove;
   end;

moveback:

 if moveNr = 1 then
  begin
   result := gstEnd;                //no solution
   topmoveNr := 0;
   exit;
  end;

 dec(moveNr);
 if addFWhistory = false then      //add to FWhistory
  begin
   result := gstEnd;
   exit;                           //if full
  end; 

 xmove := movelist[moveNr];
 with xmove do
  begin
   boardcodeDiff := getfootprint(mblk);
   blocks[mblk].pos := oldblockpos(blocks[mblk].pos,mdir);
   boardcodeDiff := boardcodeDiff xor getfootprint(mblk);
   bt := blocks[mblk].bt;
   boardcode[bt] := boardcode[bt] xor boardcodeDiff;
   popBAF(boardcodediff);
  end;
 goto nextmove1;
end;

//--- move list procedures ---

procedure erasemoveline(ix : integer);
//erases move ix 1..30 of screen
var r : Trect;
    i : byte;
begin
 r.right := -1;
 r.Top := (ix-1) * 20 + 1;
 r.Bottom := ix * 20;
 with form1.PaintBox3 do with canvas do
  begin
   brush.Style := bsSolid;
   brush.color := brushcolor3;
   for i := 0 to 2 do
    begin
     r.Left := r.Right+1;
     r.Right := hspace[i+1];
     fillrect(r);
    end;
  end;
end;

procedure showmoveline(ix,linenr : integer);
//show move lineNr at line ix of screen
var x,y : integer;
    d : byte;
    ch : char;
    s : string;
begin
 y := (ix-1) * 20 + 2;
 with form1.PaintBox3.Canvas do
  begin
   font.Name := 'arial';
   font.height := 18;
   brush.Style := bsclear;
   s := inttostr(lineNr);
   x := hspace[1] - textwidth(s) - 5;
   textout(x,y,s);
   s := blocks[movelist[lineNr].mblk].text;
   x := hspace[2] - 20;
   textout(x,y,s);
   d := movelist[linenr].mdir;
   ch := chr(dToArrow[d]);
   x := hspace[3]-25;
   font.Name := 'symbol';
   font.Height := 20;
   textout(x,y,ch);
  end;
end;

procedure showMoves;
//show moves list
var i,bias,y : integer;
begin
 if moveNr > 30 then bias := moveNr - 30 else bias := 0;
 for i := 1 to 30 do
  begin
   erasemoveline(i);
   if i+bias <= topmovenr then showmoveline(i,i+bias);
  end;
 y := (moveNr-bias-1) * 20 + 1;
 form1.PaintBox3.Canvas.Draw(0,y,form1.image1.picture.bitmap);
end;

procedure clearmovesList;
//clear moveslist, statistics, BAF data
var i,j : integer;
begin
 for i := 1 to topmoveNr do
  with movelist[i] do
   begin
    mblk := 0;
    mdir := 0;
    alldirs := 0;
   end;
 moveNr := 1;                 //points to next move
 topmoveNr := 0;              //last move in table
 for i := 1 to 10 do
 with stat do
  begin
   moves := 0;
   proctime   := 0;
   TRIALmoves := 0;
   HistSpace  := 0;
   FWrejects  := 0;
   BWrejects  := 0;
  end;
 for i := 0 to 19 do         //clear BAF data
  begin
   BAFh[i] := 0;
   for j := 0 to 50 do BAF[i,j] := 0;
  end;
end;

//--- move management ---

procedure procMouseMove;
//mouse move took place, register move
var r : Trect;
    dx,dy : integer;
    d : byte;
begin
 r := getBlockrect(oldblock);
 dx := blockrect.Left - r.Left;
 dy := blockrect.Top - r.Top;
 d := 0;
 if dx > 50 then
  begin
   inc(blocks[oldblock].pos);   //right movenent
   d := 1;
  end;
 if dx < -50 then
  begin
   dec(blocks[oldblock].pos);  //left
   d := 4;
  end;
 if dy > 50 then
  begin
   inc(blocks[oldblock].pos,4); //down
   d := 8;
  end;
 if dy < -50 then
  begin
   dec(blocks[oldblock].pos,4); //up
   d := 2;
  end;
 eraserect(blockrect);
 paintblock(oldblock);
 bmToBox;
 makeboardcode;
 if d = 0 then exit; //no move done

//-----------register move---

 with movelist[moveNr] do
  begin
   mblk := oldblock;
   mdir := d;
   alldirs := movedirs;
  end;
 if moveNr = 1 then playmove1 := true;//player started from move1
 topmoveNr := moveNr;
 inc(moveNr);
 showmoves;

//------------test oplossing---

 with form1.msgtext do
  begin
   if blocks[2].pos = 13 then
    begin
     if playmove1 then caption := 'SOLUTION FOUND ...congratulations !'
      else caption := 'solution reached';
    end
   else
    if moveNr > endmoveNr then
     Caption := 'moves list is full'
     else caption := 'find solutions...';
  end;

end;

procedure procKBmove(blk,d : byte);
//processs keyboard move
begin
 with form1.msgtext do
  if moveNr > endmoveNr then
   begin
    caption := 'list is full';
    exit;
   end
   else caption := 'find solution...';

 with movedata do
  begin
   mbrect := getBlockrect(blk);
   count := 0;
   mblk := blk;
     case d of
      1 : begin
           dx := 4; dy := 0;
           blocks[blk].pos := blocks[blk].pos + 1;
          end;
      2 : begin
           dx := 0; dy := -4;
           blocks[blk].pos := blocks[blk].pos - 4;
          end;
      4 : begin
           dx := -4; dy := 0;
           blocks[blk].pos := blocks[blk].pos - 1;
          end;
      8 : begin
           dx := 0; dy := 4;
           blocks[blk].pos := blocks[blk].pos + 4;
          end;
     end;//case
  end;//with movedata  

 makeboardcode;
 if d = 0 then exit; //no move done

//-----------register move---

 with movelist[moveNr] do
  begin
   mblk := blk;
   mdir := d;
   alldirs := movedirs;
  end;
 if moveNr <= endmoveNr then
  begin
   topmoveNr := moveNr;
   inc(moveNr);
  end;
 showmoves;
 eventblock := true;
 form1.Timer1.Enabled := true;
end;

procedure DoMove(blk,dir : byte);
//slow move on screen
//setup movedata, start timer to finish
begin
 eventblock := true;
 oldblock := 0;
 with movedata do
  begin
   count := 0;
   mblk := blk;
   mbrect := getblockrect(mblk);
   case dir of
    1 : begin
         dx := 4; dy := 0;
        end;
    2 : begin
         dx := 0; dy := -4;
        end;
    4 : begin
         dx := -4; dy:= 0;
        end;
    8 : begin
         dx := 0; dy := 4;
        end;
   end;//case;
  end;//with movedata
 form1.Timer1.Enabled := true;
end;

procedure procMove;
//move block during replay (slow motion)
begin
 if moveNr > topmoveNr then exit;

 with movelist[movenr] do
  begin
   DoMove(mblk,mdir);
   blocks[mblk].pos := newblockpos(blocks[mblk].pos,movelist[moveNr].mdir);
  end;
 makeboardcode;
 inc(moveNr);
 showmoves;
end;

procedure procmoveback;
//take last move back during PLAY  (slow motion)
const revdir : array[1..8] of byte = (4,8,0,1,0,0,0,2);
begin
 if moveNr = 1 then exit;

 dec(moveNr);
 if moveNr = 1 then form1.msgtext.Caption := ''
  else form1.msgtext.Caption := 'move '+ inttostr(moveNr-1);
 if mainbutton = mbPlay then topmoveNr := moveNr-1;
 with movelist[moveNr] do
  begin
   DoMove(mblk,revdir[mdir]);
   blocks[mblk].pos := oldblockpos(blocks[mblk].pos,movelist[moveNr].mdir);
  end;
 makeboardcode;
 showmoves;
end;

//--- game control ---

procedure resetGame;
//repaint game, make board codes, clear history
//set entry 0 of BWhistory to initial boardcode
//(boardcode must reflect initial game)
//do not change move list
var i : byte;
begin
 with bm do eraserect(rect(0,0,width,height));
 for i := 1 to 10 do blocks[i] := game1[i];
 for i := 1 to 10 do paintblock(i);
 makeboardcode;
 for i := 1 to 4 do BWhistory[i,0] := boardcode[i];
 resetHistory;
 selectBlockNr := 0;    //no block selected
 moveNr := 1;
 proccycles := 0;
 form1.PaintBox1.Invalidate;
 endmoveNr := form1.maxmoveUpDown.position;  //max move allowed in search
 gamestate := gstIdle;
end;

procedure showgame;
//repaint board
var i : byte;
begin
 with bm do eraserect(rect(0,0,width,height));
 for i := 1 to 10 do paintblock(i);
 form1.PaintBox1.Invalidate;
end;
 
procedure initPlayMode;
//called when play-mode is sekected
begin
 mainbutton := mbPlay;
 gamestate := gstIdle;
 playmove1 := false;
 with form1 do
  begin
   msgtext.Caption := 'search for solution...';
   backBtn.Enabled := true;
   maxmoveUPDown.enabled := true;
  end;

 topmoveNr := moveNr -1;
 showmoves;
end;

procedure initReplaymode;
//called when replay-mode is selected
begin
 mainbutton := mbReplay;
 gamestate := gstIdle;
 resetgame;
 moveNr := 1;
 showmoves;
 with form1 do
  begin
   goBtn.Enabled := true;
   backBtn.Enabled := true;
   if stepmode then goBtn.Caption := 'STEP' else goBtn.Caption := 'GO';
   stepcheck.Enabled := true;
   msgtext.Caption := 'show moves';
  end;
end;

procedure initSearchMode;
//called when search mode is selected
begin
 mainbutton := mbSearch;
 gamestate := gstIdle;
 resetgame;
 clearmoveslist;
 showmoves;
 with form1 do
  begin
   maxmovetext.Enabled := true;
   maxmoveUpDown.Enabled := true;
   statBtn.Enabled := true;
   goBtn.Enabled := true;
   goBtn.Caption := 'GO';
   stepcheck.Enabled := true;
   msgtext.Caption := 'click GO to start search';
  end;
end;

procedure delay(t : integer);
//delay t millisecs
var t1,t2 : integer;
begin
 t1 := gettickcount;
 repeat
  application.ProcessMessages;
  t2 := gettickcount;
 until t2 - t1 >= t;
end;

procedure GoSearch;
//control search process
var t1,t2 : Int64;
    i : byte;
begin
 repeat
  eventblock := true;
  stopflag := false;
  form1.goBtn.Caption := 'STOP';
  getCPUticks(t1);
  if stepmode then gamestate := search(1) else gamestate := search(10000);
  getCPUticks(t2);
  PROCcycles := PROCcycles + t2 - t1;
  showmoves;
  showgame;
  if stepmode then delay(333) else delay(2);
  case gamestate of
   gstpause :
     begin
      if stopflag then form1.msgtext.Caption := 'pause'
       else form1.msgtext.Caption := 'computer searching...move: '+
                                      inttostr(stat.TRIALmoves)
     end;
   gstSolved :
     begin
      stopflag := true;
      form1.msgtext.Caption := 'puzzle solved.  (see statistics)';
     end;
   gstEnd :
     begin
      stopflag := true;
      form1.msgtext.Caption := 'no solution found';
     end;
  end;//case
 until stopflag;
 with stat do
  begin
   proctime := trunc(PROCcycles/(CPUcycles*1e6));
   histspace := 0;
   for i := 0 to 3 do HistSpace := HistSpace + FWtop[i];
   moves := topmoveNr;
  end;
 eventblock := false;
 form1.goBtn.Caption := 'GO';
end;

procedure GoReplay;
//control replay process
//step or continuous
begin
 with form1 do
  begin
   if stepmode then goBtn.Caption := 'STEP' else goBtn.Caption := 'STOP';
   backBtn.Enabled := stepmode;
  end;
 repeat
  stopflag := false;
  form1.msgtext.Caption := 'move ' + inttostr(moveNr);
  procmove;
  while eventblock do application.processmessages;
  if stepmode then stopflag := true;
 until stopflag or (moveNr > topmoveNr);
 if moveNr > topmoveNr then form1.msgtext.Caption := 'end of list';
 with form1 do
  begin
   if stepmode then goBtn.Caption := 'STEP' else goBtn.Caption := 'GO';
   backBtn.Enabled := true;
  end; 
end;

// -- events --

procedure TForm1.FormCreate(Sender: TObject);
begin
 eventblock := true;
 bm := Tbitmap.Create;
 with bm do
  begin
   width := paintbox1.Width;
   height := paintbox1.Height;
   pixelformat := pf32bit;
  end;
 exbm := Tbitmap.Create;
 with exbm do
  begin
   width := paintbox2.Width;
   height := paintbox2.Height;
   pixelformat := pf32bit;
  end;
 rectfull := true;
 with paintbox1 do modrect := rect(0,0,width,height);
 form1.msgText.caption := 'welcome at the SHIFT puzzle. '+
                          'Select "play" or "search"...';
 paintex;     //paint example of solved game
 mainbutton := mbNone;
 sysButton := sysNone;
 gamestate := gstIdle;
 eventblock := false;
 resetgame;
 CPUcycles := cyclesPerMicrosecond;  //calculate cycles per microsec.
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 bm.Free;
 exbm.Free;
end;

procedure TForm1.FormPaint(Sender: TObject);
var i,j : byte;
 x1,y1,x2,y2 : integer;
begin
 for i := 0 to componentcount-1 do
  if components[i] is Tpaintbox then
    begin
     with TControl(components[i]) do
      begin
       x1 := left - 2;
       y1 := top - 2;
       x2 := left + width + 1;
       y2 := top + height + 1;
      end;
     with canvas do
      begin
       pen.Width := 1;
       for j := 0 to 1 do
        begin
         pen.Color := $000000;
         moveto(x2-j,y1+j);
         lineto(x1+j,y1+j);
         lineto(x1+j,y2-j);
         pen.color := $c0c0c0;
         lineto(x2-j,y2-j);
         lineto(x2-j,y1+j)
        end;
      end;
    end;//if 
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
//game paintbox
begin
 paintbox1.Canvas.draw(0,0,bm);
end;

procedure TForm1.PaintBox2Paint(Sender: TObject);
//example of solved game
begin
 paintbox2.Canvas.Draw(0,0,exbm);
end;

procedure TForm1.PaintBox3Paint(Sender: TObject);
//moves list
//paint background
var i : byte;
begin
 with paintbox3 do with canvas do
  begin
   brush.Color := brushcolor3;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   pen.Color := $000000;
   pen.Style := psdot;
   for i := 1 to 29 do
    begin
     moveto(0,i*20);
     lineto(width,i*20);
    end;
   for i := 1 to 2 do
    begin
     moveto(hspace[i],0);
     lineto(hspace[i],height);
    end;
  end;
 showmoves;
end;

//--- mouse events ---

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
//mouse move in game
var newblock : byte;
    dx,dy : integer;
    r : Trect;
begin
 if (mainbutton <> mbPlay) or eventblock or (moveNr > endmoveNr) then exit;

 if grip = false then
  begin
   newblock := XYtoBlock(x,y);
   if newblock <> oldblock then
    if newblock <> 0 then
     begin
      makeMoveDirs(newblock,movedirs); //movedirs is updated
      if movedirs <> 0 then
       begin
        form1.PaintBox1.Cursor := crHandpoint;
        moveblock := true;
       end;
     end
    else begin
          form1.PaintBox1.Cursor := crArrow;
          moveblock := false;
         end;
   oldblock := newblock;
  end;//if grip

 if grip then
  begin
   r := getBlockrect(oldblock);
   x := x - offsetX;
   y := y - offsetY;
   dx := x - r.left; //dx,dy = move direction from old position
   dy := y - r.top;
   if (movedirs and 1 = 0) and (dx > 0) then dx := 0;
   if (movedirs and 2 = 0) and (dy < 0) then dy := 0;
   if (movedirs and 4 = 0) and (dx < 0) then dx :=0;
   if (movedirs and 8 = 0) and (dy > 0) then dy := 0;
   if dx < -100 then dx := -100;
   if dx > 100 then dx := 100;
   if dy < -100 then dy := -100;
   if dy > 100 then dy := 100;
   if abs(dx) > abs(dy) then dy := 0 else dx := 0;

   eraserect(blockrect);                       //erase old block
   with blockrect do                           //update blockrect
    begin
     left := r.Left + dx;
     right := r.Right + dx;
     top := r.Top + dy;
     bottom := r.Bottom + dy;
    end;
   paintblockXY(blockrect.Left,blockrect.top,oldblock);  //erase old block
   bmToBox;
  end;//if grip
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var n : byte;
begin
 if (mainbutton <> mbPlay) or eventblock then exit;

 if selectblockNr <> 0 then    //deselect keyboard selected block
  begin
   n := selectblockNr;
   selectblockNr := 0;
   paintblock(n);
   bmtobox;
  end;

  if oldblock <> 0 then
   with blocks[oldblock] do
    begin
     blockrect := getBlockrect(oldblock);
     offsetX := x - blockrect.left;
     offsetY := y - blockrect.top;
     grip := true;
    end;
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if (mainbutton <> mbPlay) or eventblock then exit;

 if grip then
  begin
   procmousemove; //register move
   grip := false;
   paintbox1.Cursor := crArrow;
   oldblock := 0;
   moveblock := false;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
//takes move back
//movecounter 0..50 for movement of 100 pixels
begin
 with movedata do
  begin
   inc(count);
   eraserect(mbrect);
   mbrect.left := mbrect.Left + dx;
   mbrect.Top := mbrect.Top + dy;
   mbrect.Right := mbrect.right + dx;
   mbrect.Bottom := mbrect.Bottom + dy;
   paintblockXY(mbrect.left,mbrect.top,mblk);
   bmtobox;
   if count = 25 then
    begin
     form1.Timer1.Enabled := false;
     eventblock := false;
    end;
  end;
end;

//--- keyboard ---

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
var i,hit : byte;
begin
 if (mainbutton <> mbPlay) or eventblock then exit;

 if not (key in ['a','b','c','d','e','f','g','h','i','x']) then exit;

 i := 0;
 hit := 0;
 while (hit = 0) and (i < 10) do
  begin
   inc(i);
   if blocks[i].text = upcase(key) then hit := i;
  end;
 selectblock(hit);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var d : byte;
begin
 if (key = VK_SPACE) or (key = VK_RETURN) then
  begin
   goBtnClick(self);
   exit;
  end;

 if eventblock then exit;

 d := 0;
 case mainbutton of
  mbPlay  :  begin
              case key of
               VK_BACK : begin
                          selectblock(0);
                          procmoveback;
                          exit;
                         end;
               VK_RIGHT : d := 1;
               VK_LEFT  : d := 4;
               VK_UP    : d := 2;
               VK_DOWN  : d := 8;
              end;
              if (selectBlockNr <> 0) then
               begin
                makemovedirs(selectblockNr,movedirs);
                if (d and movedirs) = d then procKBmove(selectBlockNr,d);
               end;
             end;
  mbReplay : case key of
              VK_BACK : procmoveback;
             end;
 end;//case
end;

//--- button events ---

procedure TForm1.playBtnClick(Sender: TObject);
//common code for all menu buttons (search, replay,play)
begin
 if eventblock then        //restore mainbutton
  begin
   case mainbutton of
    mbPlay   : playBtn.Down := true;
    mbReplay : ReplayBtn.down := true;
    mbSearch : SearchBtn.Down := true;
   end;//case
  exit;
 end;

 if gamestate <> gstIdle then application.ProcessMessages;//wait for timer

 maxmoveUPDOWN.Enabled := false;  //disable all buttons
 backBtn.Enabled := false;
 goBtn.Enabled := false;
 statBtn.Enabled := false;
 stepCheck.enabled := false;

 mainbutton := mbNone;
 if Tspeedbutton(sender).Down = false then exit;

 if sender = playBtn then initplaymode;
 if sender = ReplayBtn then initReplaymode;
 if sender = searchBtn then initsearchmode;
end;

procedure TForm1.resetBtnClick(Sender: TObject);
begin
 if eventblock then exit;

 msgtext.Caption := '';

 case mainbutton of
  mbSearch : clearmoveslist;
  mbPlay   : clearmoveslist;
  mbReplay : moveNr := 1;
 end;
 resetgame;  //also clears history
 showmoves;
end;

procedure TForm1.goBtnClick(Sender: TObject);
begin
 case mainbutton of
  mbSearch,
  mbReplay : stopflag := true;
 end;

 if eventblock then exit;

 case mainbutton of
  mbSearch : GoSearch;
  mbReplay : GoReplay;
 end;//case
end;

procedure TForm1.BackBtnClick(Sender: TObject);
begin
 if eventblock then exit;

 case mainbutton of
  mbPlay,
  mbReplay : procmoveback;
 end;
end;

procedure TForm1.stepcheckClick(Sender: TObject);
begin
 stepmode := stepcheck.Checked;
 activecontrol := nil;
end;

procedure TForm1.statBtnClick(Sender: TObject);
begin
 if eventblock then exit;
 
 statform.execute(stat);
end;

procedure TForm1.maxmoveUpDownMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if eventblock then exit;

 if maxmoveUpDown.position >= moveNr then
   endmoveNr := maxmoveUpDown.position          //cannot move below movNr-1
  else
   begin
    endmoveNr := moveNr - 1;
    maxmoveUpDown.position := endmoveNr;
   end;
 msgtext.Caption := '';  
end;

//--- davdata ---

procedure TForm1.Label7Click(Sender: TObject);
begin
 shellexecute(handle,'open',Pchar('http://www.davdata.nl/'),nil,nil,SW_SHOW);
end;

procedure TForm1.Label7MouseEnter(Sender: TObject);
begin
 with label7 do
  begin
   font.Color := $0000ff;
   font.Style := [fsunderline];
  end;
end;

procedure TForm1.Label7MouseLeave(Sender: TObject);
begin
 with label7 do
  begin
   font.Color := $ff0000;
   font.style := [];
  end;
end;

//--- printen ---

procedure printblocks(x,y : integer;const g : Tgame; m : single);
//print blocks of g at position [x,y]
var i,n,bt : byte;
    r : Trect;
    d : byte;
    c : char;
    tX,tY : word;
begin
 with printer.canvas do
  for i := 1 to 10 do
   begin
    bt := g[i].bt;
    brush.Color := blocktype[bt].color;
    brush.Style := bssolid;
    r.Left := trunc(x + (g[i].pos and $3) * 0.75 * m);
    r.Top := trunc(y + (g[i].pos div 4) * 0.75 * m);
    r.Right := r.Left + trunc(blocktype[bt].w * 0.75 * m);
    r.Bottom := r.Top + trunc(blocktype[bt].h * 0.75 * m);
    fillrect(r);

    d := trunc(0.1 * m);
    pen.Width := 1;
    brush.Style := bsClear;
    for n := 0 to d-1 do
     begin
      pen.color := $a0a0a0;
      moveto(r.Right-1-n,r.Top+n);
      lineto(r.Left+n,r.Top+n);
      lineto(r.Left+n,r.Bottom-1-n);
      pen.color := $404040;
      lineto(r.Right-1-n,r.Bottom-1-n);
      lineto(r.Right-1-n,r.top+n);
     end;
     c := g[i].text;
     font.Name := 'arial';
     font.Color := $000000;
     font.Height := trunc(0.5 * m);
     font.Style := [fsBold];
     tX := r.Left + (r.Right - r.Left - textwidth(c)) div 2;
     tY := r.Top + (r.bottom - r.Top - textheight(c)) div 2;
     d := trunc(m/40);
     textout(tX+d,tY+d,c);
     font.Color := $ffffff;
     textout(tX,tY,c);
   end;
end;

procedure printsolution;
type Tline = record
              size : single;
              x,y  : single;
              text : string;
             end;
const leftmargin = 1.5;
      topmargin  = 1;
      toptext    = 6;
      prheight   = 0.4;
      gamewidth  = 3;
      gameheight = 3.75;
      game1left  = 12.5;
      game2left  = 16.5;
      gametop    = 1.5;
      lineCount  = 30;
      columnwidth= 2.5;
      vspacing   = 0.6;
      columncount= 7;

    prlines : array[1..6] of Tline =
              ((size: 0.75; x: 1.5;  y: 1.5; text: 'SHIFT puzzle'),
               (size: 0.35; x: 12.5; y: 1;   text: 'start position'),
               (size: 0.35; x: 16.5; y: 1;   text: 'final position'),
               (size: 0.4;  x: 1.5 ; y: 5.25;text: 'moves'),
               (size: 0.6;  x: 1.5;  y: 26;  text: 'DavData Software'),
               (size: 0.5;  x: 10;   y: 26;  text: 'www.davdata.nl'));

var mult : single;
    x,y : word;
      i : byte;
      r : Trect;
      s : string;
      col,line : word;
begin
 with printer do with canvas do
  begin
   begindoc;
   mult := pagewidth / 20;  //pixels per cm
   font.name := 'arial';
   font.style := [];
   font.color := $000000;
   brush.Style := bsClear;

   for i := 1 to 6 do
    begin
     x := trunc(prlines[i].x * mult);
     y := trunc(prlines[i].y * mult);
     font.Height := trunc(prlines[i].size * mult);
     textout(x,y,prlines[i].text);
    end;
   font.height := trunc(0.5*mult);
   y := trunc(3.5 * mult);
   x := trunc(1.5 * mult);
   textout(x,y,datetostr(date));

   r.Left := trunc(leftmargin * mult);
   r.Right := trunc((leftmargin+columncount*columnwidth)*mult);
   r.Top := trunc(toptext * mult);
   r.Bottom := trunc((toptext + lineCount * vspacing )* mult);
   rectangle(r);
   pen.Width := trunc(mult / 120 + 0.5);
   for i := 1 to columncount-1 do
    begin
     x := trunc((leftmargin + i*columnwidth)*mult);
     moveto(x,r.Top);
     lineto(x,r.Bottom);
    end;

   font.Height := trunc(prheight * mult);
   for i := 1 to topMoveNr do
    begin
     col := (i-1) div lineCount;
     line := (i-1) mod lineCount;
     s := inttostr(i);
     font.Name := 'arial';
     x := trunc((leftmargin + 0.75 + col * columnwidth) * mult) - textwidth(s);
     y := trunc((toptext + line * vspacing) * mult);
     textout(x,y,s);
     s := game1[movelist[i].mblk].text;
     x := trunc((leftmargin + 1.6 + col * columnwidth) * mult) - textwidth(s);
     textout(x,y,s);
     font.name := 'symbol';
     s := chr(dToArrow[movelist[i].mdir]);
     x := trunc((leftmargin + 2.2 + col * columnwidth) * mult) - textwidth(s);
     textout(x,y,s);
    end;
    x := trunc(game1left * mult);
    y := trunc(gametop * mult);
    printblocks(x,y,game1,mult);
    x := trunc(game2left * mult);
    printblocks(x,y,blocks,mult);
    enddoc;
  end;//with printer
 form1.msgtext.Caption := 'puzzle send to printer';
end;

//--- save & load ---

procedure SaveGame;
var f : file;
    buf : array[1..250] of byte;
    i,count,n : byte;
    path,s,fname : string;
begin
 for i := 1 to 250 do buf[i] := 0;
 n := 1;
 with form1.savedialog1 do
 if execute then    // Display Open dialog box
  begin
   path := Extractfilepath(filename);
   s := 'SHIFT_ ' + ExtractRelativePath(filename,filename);
   count := length(s);
   if count > 25 then
    begin
     delete(s,25,count-25);
     count := 25;
    end;
   fname := path + s;
   buf[n] := count;
   for i := 1 to count do
    begin
     inc(n);
     buf[n] := byte(s[i]);
    end;
   inc(n);
   buf[n] := topmoveNr;
   for i := 1 to topmoveNr do
    begin
     inc(n);
     buf[n] := (movelist[i].mblk shl 4) or movelist[i].mdir;
    end;

   assignfile(f,fname);
   rewrite(f,1);
   blockwrite(f,buf,sizeOf(buf));
   closefile(f);
   form1.msgtext.Caption := 'puzzle saved as: ' + s;
  end;//if execute
end;

procedure loadGame;
const ft1 = 'read error';
      ft2 = 'wrong file';
var f : file;
    buf : array[1..250] of byte;
    i,n : byte;
    count : integer;
    s,s1 : string;
begin
 for i := 1 to 250 do buf[i] := 0;
 with form1.opendialog1 do
  if execute then
   begin
    assignfile(f,filename);
    reset(f,1);
    blockread(f,buf,sizeOf(buf),count);
    closefile(f);
    if (ioresult <> 0) or (count <> 250) or (buf[1] > 16) then
     begin
      form1.msgtext.Caption := ft1;
      exit;
     end;
     s := '';
    for i := 1 to buf[1] do s := s + chr(buf[i+1]);
    s1 := copy(s,1,6);
    delete(s,1,6);
    if s1 <> 'SHIFT_' then
     begin
      form1.msgtext.Caption := ft2;
      exit;
     end;
    n := buf[1] + 2;
    count := buf[n];

    clearmoveslist;
    for i := 1 to count do
     begin
      movelist[i].mblk := buf[n+i] shr 4;
      movelist[i].mdir := buf[n+i] and $f;
     end;
    topmoveNr := count;
    showmoves;
    form1.msgtext.Caption := 'puzzle '+ s + ' opened';
   end;
end;

//--- system ---

function getSysrect(sys : TsysBtn) : Trect;
//return rectangle on Form1 canvas of system element n
var Ximage : Timage;
begin
 with form1 do
  case sys of
   sysOpen : Ximage := open_image;
   sysSave : Ximage := save_image;
   sysprint: Ximage := pr_image;
   sysSetup: Ximage := pr_setup;
  end;
 with Ximage do
  begin
   result.Left := left - 2;
   result.Right := left + width + 2;
   result.top := top - 2;
   result.bottom := top + height + 2;
  end;
end;

procedure Sysframe(col : longInt);
//paint frame around sysbutton
var r : Trect;
begin
 r := getSysrect(sysButton);
 with form1.Canvas do
  begin
   pen.Width := 2;
   pen.color := col;
   brush.style := bsClear;
   rectangle(r);
  end;
end;

procedure TForm1.open_imageMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var newButton : TsysBtn;
begin
 if eventblock then exit;
 
 with sender as TImage do
  begin
   newButton := TsysBtn(tag);
   if newButton <> sysButton then
    begin
     if sysButton <> sysNone then sysframe(form1.color);
     sysButton := newButton;
     if sysButton <> sysNone then sysframe($ff0000);
    end;
  end;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
//deselect system button if mouse outside buttons
begin
 if sysButton <> sysNone then
  begin
   sysframe(color);
   sysButton := sysNone;
  end;
end;

procedure TForm1.open_imageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if eventblock then exit;

 case sysbutton of
  sysOpen  : loadgame;
  sysSave  : saveGame;
  sysPrint : printsolution;
  sysSetup : printerSetupDialog1.execute;
 end;
 sysframe(form1.Color);
 sysbutton := sysNone;
end;

procedure TForm1.helpBtnClick(Sender: TObject);
begin
 if eventblock then exit;

 showhelp;
end;

end.
